typedef struct {
    struct bt_gatt_attr attrs[6];
    struct bt_gatt_service service;
} pt_ble_nus_t;

pt_ble_nus_t pt_ble_nus;

void pt_ble_nus_tx_ccc_cfg_changed(const struct bt_gatt_attr *attr fd_unused, uint16_t value) {   
    bool notify = (value == BT_GATT_CCC_NOTIFY);
    ...
}

ssize_t pt_ble_nus_rx_write(
    struct bt_conn *conn fd_unused, const struct bt_gatt_attr *attr fd_unused, const void *data, uint16_t length, uint16_t offset fd_unused, uint8_t flags fd_unused
) {
    ...
    return length;
}

void pt_ble_nus_attr_tx(void) {
    static struct bt_uuid_128 uuid = {
        .uuid = { BT_UUID_TYPE_128 },
        .val = { PT_BLE_NUS_UUID_TX_VAL },
    };
    static struct bt_uuid_16 gatt_chrc_uuid = { .uuid = { BT_UUID_TYPE_16 }, .val = BT_UUID_GATT_CHRC_VAL };
    static struct bt_gatt_chrc chrc_user_data = {
        .uuid = (struct bt_uuid *)&uuid,
        .value_handle = 0U,
        .properties = BT_GATT_CHRC_NOTIFY,
    };
    pt_ble_nus.attrs[1] = (struct bt_gatt_attr) {
        .uuid = (struct bt_uuid *)&gatt_chrc_uuid,
        .read = bt_gatt_attr_read_chrc,
        .write = (void *)0,
        .user_data = (void *)&chrc_user_data,
        .handle = 0,
        .perm = BT_GATT_PERM_READ,
    };

    pt_ble_nus.attrs[2] = (struct bt_gatt_attr) {
        .uuid = (struct bt_uuid *)&uuid,
        .read = (void *)0,
        .write = (void *)0,
        .user_data = (void *)0,
        .handle = 0,
        .perm = BT_GATT_PERM_READ,
    };

    static struct bt_uuid_16 gatt_ccc_uuid = { .uuid = { BT_UUID_TYPE_16 }, .val = BT_UUID_GATT_CCC_VAL };
    static struct _bt_gatt_ccc ccc = {
        .cfg = {},
        .cfg_changed = pt_ble_nus_tx_ccc_cfg_changed,
        .cfg_write = (void *)0,
        .cfg_match = (void *)0,
    };
    pt_ble_nus.attrs[3] = (struct bt_gatt_attr) {
        .uuid = (struct bt_uuid *)&gatt_ccc_uuid,
        .read = bt_gatt_attr_read_ccc,
        .write = bt_gatt_attr_write_ccc,
        .user_data = (void *)&ccc,
        .handle = 0,
        .perm = BT_GATT_PERM_READ | BT_GATT_PERM_WRITE,
    };
}

void pt_ble_nus_attr_rx(void) {
    static struct bt_uuid_128 uuid = {
        .uuid = { BT_UUID_TYPE_128 },
        .val = { PT_BLE_NUS_UUID_RX_VAL },
    };
    static struct bt_uuid_16 gatt_chrc_uuid = { .uuid = { BT_UUID_TYPE_16 }, .val = BT_UUID_GATT_CHRC_VAL };
    static struct bt_gatt_chrc chrc_user_data = {
        .uuid = (struct bt_uuid *)&uuid,
        .value_handle = 0U,
        .properties = BT_GATT_CHRC_WRITE | BT_GATT_CHRC_WRITE_WITHOUT_RESP,
    };
    pt_ble_nus.attrs[4] = (struct bt_gatt_attr) {
        .uuid = (struct bt_uuid *)&gatt_chrc_uuid,
        .read = bt_gatt_attr_read_chrc,
        .write = (void *)0,
        .user_data = (void *)&chrc_user_data,
        .handle = 0,
        .perm = BT_GATT_PERM_READ,
    };
    pt_ble_nus.attrs[5] = (struct bt_gatt_attr) {
        .uuid = (struct bt_uuid *)&uuid,
        .read = (void *)0,
        .write = pt_ble_nus_rx_write,
        .user_data = (void *)0,
        .handle = 0,
        .perm = BT_GATT_PERM_READ | BT_GATT_PERM_WRITE,
    };
}

void pt_ble_nus_register(void) {
    static struct bt_uuid_16 gatt_primary_uuid = { .uuid = { BT_UUID_TYPE_16 }, .val = BT_UUID_GATT_PRIMARY_VAL };
    static struct bt_uuid_128 service_uuid = { .uuid = { BT_UUID_TYPE_128 }, .val = { PT_BLE_NUS_UUID_SERVICE_VAL } };
    pt_ble_nus.attrs[0] = (struct bt_gatt_attr) {
        .uuid = (struct bt_uuid *)&gatt_primary_uuid,
        .read = bt_gatt_attr_read_service,
        .write = (void *)0,
        .user_data = (void *)&service_uuid,
        .handle = 0,
        .perm = BT_GATT_PERM_READ,
    };

    pt_ble_nus_attr_tx();
    pt_ble_nus_attr_rx();

    pt_ble_nus.service = (struct bt_gatt_service) { .attrs = pt_ble_nus.attrs, .attr_count = ARRAY_SIZE(pt_ble_nus.attrs) };
	int result = bt_gatt_service_register(&pt_ble_nus.service);
    fd_assert(result >= 0);
}
